##
##  openpkg-darwin.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         openpkg-darwin
Summary:      OpenPKG Darwin Integration
URL:          http://www.openpkg.org/
Vendor:       OpenPKG Project
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        System
License:      OpenPKG
Version:      0
Release:      20100329

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101
Provides:     binutils = %{version}
Provides:     gcc = %{version}
Provides:     gcc::with_cxx = yes

%description
    This package is a cruel hack until upstream GNU binutils and GNU
    gcc really support Darwin / Mac OS X out of the box: it proxies the
    Darwin occtools and gcc tools as the OpenPKG "binutils" and "gcc"
    virtual packages.

%track
    prog openpkg-darwin = {
        disabled
        version   = %{version}
        comment   = "this is a meta-package without any vendor sources"
        url       = http://www.openpkg.org/
        regex     = .*
    }

%prep
    %setup -q -T -c

%build

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1
    for tool in c%{l_nil}c gcc c++ g++; do
        (   echo "#!/bin/sh"
            echo "case \" \$* \" in"
            echo "    *\" -c \"* | *\" -E \"* ) exec /usr/bin/$tool \${1+\"\$@\"} ;;"
            echo "    * ) exec /usr/bin/$tool -Wl,-search_paths_first \${1+\"\$@\"} ;;"
            echo "esac"
        ) >$tool
        %{l_shtool} install -c -m 755 \
            $tool $RPM_BUILD_ROOT%{l_prefix}/bin/$tool
    done
    for tool in ld; do
        (   echo "#!/bin/sh"
            echo "exec /usr/bin/ld -search_paths_first \${1+\"\$@\"}"
        ) >$tool
        %{l_shtool} install -c -m 755 \
            $tool $RPM_BUILD_ROOT%{l_prefix}/bin/$tool
    done
    for tool in cpp gcov \
        ar as gprof nm ranlib size strip strings; do
        (   echo "#!/bin/sh"
            echo "exec /usr/bin/$tool \${1+\"\$@\"}"
        ) >$tool
        %{l_shtool} install -c -m 755 \
            $tool $RPM_BUILD_ROOT%{l_prefix}/bin/$tool
    done
    for tool in objcopy objdump readelf; do
        (   echo "#!/bin/sh"
            echo "echo 'GNU binutils command $tool(1) not supported under Darwin / Mac OS X' 1>&2"
            echo "exit 1"
        ) >$tool
        %{l_shtool} install -c -m 755 \
            $tool $RPM_BUILD_ROOT%{l_prefix}/bin/$tool
    done
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

